c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************      
      SUBROUTINE INTER_MAT
      
      INCLUDE 'VPSC7.DIM'
      DIMENSION aux4848(48,48) 
      
      iphel=1
      NSLIPMODES=NMODES(IPHEL)-NTWMOD(IPHEL)
      ns=0
      i=1
      do nm=1,NSLIPMODES
        do ix=1,NSM(nm,iphel)!NSLSYS(iphx)
          ns=ns+1
          ns1=0
          do nm1=1,NSLIPMODES
            do ix1=1,NSM(nm1,iphel)!NSLSYS(iphx)
              ns1=ns1+1            
              if (ns.eq.ns1) then
                XINTER_SYS(ns,ns1)= XINTER(nm,1)**2 !mode self interaction
              elseif (nm.eq.nm1.and.ns.ne.ns1) then
                XINTER_SYS(ns,ns1)= XINTER(nm,2)**2 !mode interaction between systems 
              elseif (nm.lt.nm1) then
                XINTER_SYS(ns,ns1)=XINTER(nm,nm1-nm+2)**2 !interaction between modes
              elseif (nm.gt.nm1) then
                XINTER_SYS(ns,ns1)=XINTER_SYS(ns1,ns)
              endif
            enddo  
          enddo  
        enddo       
      enddo 
      n_sys=ns 
       do i=1,NSYSMX
           do j=1,NSYSMX
               aux4848(i,j)=XINTER_SYS(i,j)
           enddo
       enddo
              
       do i=1,18
c          write(126,'(18f8.2)') XINTER_SYS(i,1:18)
       enddo

        CAll INVERSE(aux4848,n_sys,NSYSMX,XINTER_SYS_INV) !MZ_inter_2nd
		
c       write(126,*)'**********************************'
       do i=1,15
c          write(126,'(15f16.5)') XINTER_SYS_INV(i,1:15)
       enddo 
          
      
      RETURN
      END
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
      SUBROUTINE INVERSE(a,n,np,y)
      
      INTEGER indx(np)
      REAL a(np,np),y(np,np)
      
        do  i=1,n
          do  j=1,n
              y(i,j)=0.
          enddo 
          y(i,i)=1.
        enddo 
        call ludcmpc(a,n,np,indx,d) !Decompose the matrix just once.
        do  j=1,n !Find inverse by columns.
          call lubksbc(a,n,np,indx,y(1,j))
c        Note that FORTRAN stores two-dimensional matrices by column, so y(1,j) is the
c        address of the jth column of y.
        enddo 
      
      RETURN
      END      
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c******************************************************************************* 
      SUBROUTINE ludcmpc(a,n,np,indx,d)
      INTEGER n,np,indx(n),NMAX
      REAL d,a(np,np),TINY
      PARAMETER (NMAX=500,TINY=1.0e-20)
      INTEGER i,imax,j,k
      REAL aamax,dum,sum,vv(NMAX)
      d=1.
      do 12 i=1,n
        aamax=0.
        do 11 j=1,n
          if (abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
11      continue
        if (aamax.eq.0.) pause 'singular matrix in ludcmp'
        vv(i)=1./aamax
12    continue
      do 19 j=1,n
        do 14 i=1,j-1
          sum=a(i,j)
          do 13 k=1,i-1
            sum=sum-a(i,k)*a(k,j)
13        continue
          a(i,j)=sum
14      continue
        aamax=0.
        do 16 i=j,n
          sum=a(i,j)
          do 15 k=1,j-1
            sum=sum-a(i,k)*a(k,j)
15        continue
          a(i,j)=sum
          dum=vv(i)*abs(sum)
          if (dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
16      continue
        if (j.ne.imax)then
          do 17 k=1,n
            dum=a(imax,k)
            a(imax,k)=a(j,k)
            a(j,k)=dum
17        continue
          d=-d
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(a(j,j).eq.0.)a(j,j)=TINY
        if(j.ne.n)then
          dum=1./a(j,j)
          do 18 i=j+1,n
            a(i,j)=a(i,j)*dum
18        continue
        endif
19    continue
      return
      END
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c******************************************************************************* 
      SUBROUTINE lubksbc(a,n,np,indx,b)
      INTEGER n,np,indx(n)
      REAL a(np,np),b(n)
      INTEGER i,ii,j,ll
      REAL sum
      ii=0
      do 12 i=1,n
        ll=indx(i)
        sum=b(ll)
        b(ll)=b(i)
        if (ii.ne.0)then
          do 11 j=ii,i-1
            sum=sum-a(i,j)*b(j)
11        continue
        else if (sum.ne.0.) then
          ii=i
        endif
        b(i)=sum
12    continue
      do 14 i=n,1,-1
        sum=b(i)
        do 13 j=i+1,n
          sum=sum-a(i,j)*b(j)
13      continue
        b(i)=sum/a(i,i)
14    continue
      return
      END
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************  
      SUBROUTINE PLOTTING(istep)
      
      INCLUDE 'VPSC7.DIM'
      DIMENSION wgt_cg(NGRMX)
      
      if (istep.eq.1) then
        do ng=1,ngr(1)
          wgt_cg(ng)=wgt(ng)
        enddo
      endif 
      
      TVF_t=0.0
      TVF_c=0.0
      TVF_w=0.0
      wgt_r=0.0
      
      ng=0
      do iph=1,1
        NSLIPMODES=NMODES(iph)-NTWMOD(iph)  
        do igr=ngr(iph-1),ngr(iph)
          ng=ng+1  
          nt=0
          do im=1,nmodes(iph)
            if (im.gt.NSLIPMODES) then
            do is=1,nsm(im,iph)
              nt=nt+1
              if (nt.le.6) then
                TVF_t=TVF_t+TWFRSY(nt,ng)*wgt_cg(ng)
              elseif (nt.gt.6) then
                TVF_c=TVF_c+TWFRSY(nt,ng)*wgt_cg(ng)
              endif
            enddo
            endif
          enddo
        enddo
      enddo
      
      ng=0
      do iph=1,1
        do igr=ngr(iph-1),ngr(iph)
          ng=ng+1
          if (KTWSMX(ng).ne.0) then
            wgt_r=wgt_r+wgt(ng+ngr(1))
            TVF_w=TVF_w+TWFRSY(KTWSMX(ng)-15,ng)*wgt_cg(ng)
          endif
        enddo
      enddo
         
c      write(126,'(15f15.6)') TVF_t,TVF_c,wgt_r,TVF_w      
      
      RETURN
      END
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************       
      SUBROUTINE DEBUG
      
      INCLUDE 'VPSC7.DIM'
      DIMENSION s_s(50)
      
      !checking one grain evolution of disloc dens
      !find shear strain
      tot_shear=0.0
      do is=1,18
          !calculate accumulated shear strain on each system in a grain
          s_s(is)=s_s(is)+gamdot(is,1)*tincr
          tot_shear=tot_shear+s_s(is)
      enddo
          !plot acc shear with disloc dens  
      !IPC RT 3500/s TEST 5 sec tw     
      write(126,'(100f25.5)') epsvm,s_s(1),
     #    RHO_DEB(1),RHO_S(1,1)
c     #    twfrsy(24,53),CRSS(42,53)

     
          
      !plot CRSS of grains 
          
c      write(126,'(20f25.5)') twfrsy(31-18,42),CRSS(3,42+50)
c     # ,rho_s(3,42+50),wgt(42+50)
      
c      write(126,'(20f25.5)') s_s(33),twfrsy(33-18,51),KTWSMX(51) 
c     $ ,twfrsy(3,1),KTWSMX(1)
      
      
      
      
c********************************************************************************      
c     TESTS      
      !IPC RT 3500/s TEST 5 sec tw     
c      write(126,'(20f25.5)') epsvm,twfrsy(5,29),twfrsy(13,79), !
c     #    wgt(29),wgt(79), wgt(129)      
c      
      !IPC RT 3500/s TEST 6 sec tw     
c      write(126,'(50f25.5)') twfrsy(13,79),wgt(129),CRSS(1:42,129)
      
      RETURN
      END
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************
c*******************************************************************************             
